with("plot.x");

N = 500000;

x = zeros(N);
y = zeros(N);
x[1] = 0.5;
y[1] = 0.5;

z = [0.5; 0.5];
p = [0.85, 0.92, 0.99, 1.00];
A1 = [0.85, 0.04; -0.04, 0.85];
b1 = [0; 1.6];
A2 = [0.20, -0.26; 0.23, 0.22];
b2 = [0; 1.6];
A3 = [-0.15, 0.28; 0.26, 0.24];
b3 = [0; 0.44];
A4 = [0, 0; 0, 0.16];


for k = 2 : N
     r = rand(1);
     if r < p[1]
          z = A1 * z + b1;
     elseif r < p[2]
          z = A2 * z + b2;
     elseif r < p[3]
          z = A3 * z + b3;
     else
          z = A4 * z;
     end
     x[k] = z[1];
     y[k] = z[2];
end

fig = figure.new();
fig.plot{x=x, y=y, linetype="dot", linewidth=0.2, color=[0.0, 0.9, 0.3]};
//fig.plot{x=x, y=y};
//fig.title="fern"
fig.style="empty";
fig.save("fern.eps");
