/*
x1 = linspace(0, 1.5*pi, 100);
x2 = linspace(0.5*pi, 2*pi, 100);

x = [x1, x2];
   
y = 0.39*sin(2*x);
z = 1.22*cos(3*x);
*/

x = linspace(0, 1, 7);
f = x -> 2/3*exp(-log(2)*x) + 1/3*exp(log(2)*x);

fig = figure.new();
fig.plot(x,f(x), *, *, *, *);


fig.save("eeeefgg.eps");



x = linspace(-5, 5, 10);
f = x -> cos(x);
fig = figure.new();

/* draw small circles at (x,y) locations */
/* color is vector of 3 numbers between 0 and 1, a in rgb format */
fig.plot{x=x, y=f(x), linetype="circle", color=[1, 0, 0]};

/* connect the dots with solid lines, linetype is the default value "solid" */
fig.plot{x=x, y=f(x), color=[0,1,0.5], linewidth=2};

/* draw circular dots at location underneath the previous curve */
fig.plot{x=x, y=f(x) -1, linetype="dot", color=[1, 0, 1]};

/* connect the dots with smooth curve */
fig.plot{x=x, y=f(x) -1, linetype="curve", color = [0, 0, 1]};

/* set the xrange and yrange of the picutre */
fig.setXrange([-5.5, 5.5]);
fig.setYrange([-2.5, 1.5]);

fig.save("curves.eps");


P = x -> 0.02 * x.^3 + 10 - x.^2 + x - 1;

/*
x = [1.3, 0.5, 0, 1, 1, 0, -0.5];
y = [0.7, 0.7, 1, 1, 0, 0, 1];
*/

x = linspace(-2,3,15);
xx = [-2, -1, 0, 0.5, 1, 2, 3];
yy = P(xx) - 3;
y = P(x) - 3;


fig = figure.new();

h = 10 * sin(pi/3);
x = [-5, 5, 0];
y = [-h/3, -h/3, h*2/3];

/* the big solid triangle */
fig.polygon(x, y, "solid", [0.2, 1, 0.2]);

/* remove the center of triangle whose vertices are x and y */
remove_triangle_center = function (fig, x, y) -> ()
    L = norm([x[2] - x[1], y[2] - y[1]]);
    xo = x.mean;
    yo = y.mean;

    xm = [x[1] + x[2], x[2] + x[3], x[3] + x[1]] / 2;
    ym = [y[1] + y[2], y[2] + y[3], y[3] + y[1]] / 2;

    /* [1, 1, 1] is color white -- to remove the center */
    fig.polygon(xm, ym, "solid", [1, 1, 1]);

    theta = pi/5;
    for k = 1 : 10
         cx = xo + L * 0.08*cos(k * theta);
         cy = yo + L * 0.08*sin(k * theta);
         
         /* draw an ellipse; x and y are center coordinates
	                          0.5 and 0.4 are long and short axis
                             0 is angle between long axis and horizontal
                             "contour" is the style -- other option is "solid"
	        						[1, 0, 1] is the color -- r=1, g=0, b=1
          */
         fig.ellipse(cx, cy, 0.04 * L, 0.03 * L, 0, "contour", [1, 0, 1]);
    end

    if L >= 1
         this(fig, [xm[1], x[2], xm[2]], [ym[1], y[2], ym[2]]);
         this(fig, [xm[2], x[3], xm[3]], [ym[2], y[3], ym[3]]);
         this(fig, [xm[3], x[1], xm[1]], [ym[3], y[1], ym[1]]);
    end
end

remove_triangle_center(fig, x, y);

fig.setXrange([-5, 5]);
fig.setYrange([-5, 9]);

fig.title = "Sierpinsky blanket with flower pattern";
fig.style = "empty";
fig.save("figure.eps")



chart = piechart.new((0.6, 0.25, 0.15), ("aaa", "bbb", "ccc"));
chart.font = "Courier";
chart.save("pie.eps");

hist = histogram.new(("a", "b", "c"), ((0.6, 0.25, 0.15), (0.7, 0.32, 0.27), (0.9, 0.2, 0.5)), ("Ocean", "Lake", "Pond"));
hist.font = "Courier";
hist.fontstyle = "Bold";
hist.save("hist.eps");
f = x -> x;


