
// a bunch of miscellaneous functions for testing purposes

count = 0;

// the "false position" method

falsesolve = function (f, a, b, tol) -> c
                      while b - a > tol
                              c = a-f(a)*(b-a)/(f(b)-f(a));
                              fafc = f(a)*f(c);
                              if fafc<0
                                   b=c;
                              elseif fafc>0
                                   a=c;
                              else
                                   break;
                              end
                      end
                 end


binomialp = function [n=25, p=0.8, intro] x -> px
             v = 1;
             for k = (x+1) : n
                  v *= (k / (k - x));
             end; 
             px = v * p^x * (1-p)^(n-x);
   end

binomialp.intro = "Binomial probability. Usage: binomialp(k)";
binomialp(13)


     s = 0;
	  s[1]=0;
n=10000000;
t1 = clock();
     for k = 1 : n
          s += k;
     end

etime(t1)


// test named argument
nptest1 = function (a=3, b=5, c=9,d=10) -> s
                      printf("a = %g, b = %g, c = %g, d = %g", a, b, c, d);
                      s = a+b+c+d;
   end

nptest1{c=33,d=52}


// row echelon form of matrix

rrechf = function X  -> R
              m = X.nrows;
              n = X.ncolumns;
              N = min(m, n);
              hprev = 1;

              for j = 1 : N
                   d = X[hprev, j];
                   k = hprev;
                   while d == 0 && k < m
                        ++k;
                        d = X[k, j];
                   end

                   if d != 0
                        if k != hprev
                             for p = j : n
                                  temp = X[k, p];
                                  X[k, p] = X[hprev, p];
                                  X[hprev, p] = temp;
                             end
                        end
                        
                        for p = (hprev + 1) : m
                             alpha = X[p, j] / X[hprev, j];
                             X[p, j] = 0;
                             X[p, j + 1 : n] = X[p, j + 1 : n] - alpha * X[hprev, j + 1 : n];
									  /*
                             for k = j + 1 : n
                                  X[p, k] = X[p, k] - alpha * X[hprev, k];
                             end
									  */
                        end

                        ++ hprev;
                   end
              end

              R = X;
         end

A = [0, 3, 5, 2, 0; 1, 2, 3, 5, 2; 4, 0, 0, 8,9]

rrechf(A)

A = rand(19,20);
x = A[1:19, 1:19] \ A[1:19,20];
R = rrechf(A);
xr = R[1:19, 1:19] \ R[1:19,20];
norm(x-xr)


// Strass matrix multiplication

global.Strass = function (A, B, nmin) -> C
      n = nrows(A);
      if n < nmin
         C = A * B;
      else
         m = n/2; u = 1 : m; v = m+1 : n;
         P1 = Strass(A[u, u] + A[v, v], B[u, u] + B[v, v], nmin);
         P2 = Strass(A[v, u] + A[v, v], B[u, u], nmin);
         P3 = Strass(A[u, u], B[u, v]-B[v,v], nmin);
         P4 = Strass(A[v,v], B[v,u]-B[u,u], nmin);
         P5 = Strass(A[u,u] + A[u,v], B[v,v], nmin);
         P6 = Strass(A[v,u]-A[u,u], B[u,u] + B[u,v], nmin);
         P7 = Strass(A[u,v]-A[v,v], B[v,u]+B[v,v], nmin);
         C = [P1+P4-P5+P7, P3+P5; P2+P4, P1+P3-P2+P6];
      end
      end

A=rand(128,128);
   
B = rand(128,128);
   
nmin=8;
   
S = Strass(A,B,nmin);
norm(S-A*B)

// bisection method
bisect = function (f, a, b, delta) -> (c, err, yc) 
         ya = f(a);
         yb = f(b);
         max1 = 1 + fix((ln(b-a)-ln(delta))/ln(2));
         for k = 1 : max1
            c=(a+b)/2;
            yc=f(c);
            if yc == 0
              a=c;
              b=c;
             elseif yb*yc>0
               b=c;
               yb=yc;
              else
            a=c;
               ya=yc;
              end
      end
         c=(a+b)/2;
         err=abs(b-a);
         yc=f(c);

      end

bisect(x->3-x^2, 0, 5, 1e-8)


// simple implementation of fast Fourier transform

global.FFTRecur = function x -> y
      n = length(x);
      if n == 1
         y = x;
      else
         m = n / 2;
         yT = FFTRecur((x[1:2:n])');
         yB = FFTRecur((x[2:2:n])');
         d = exp(-2*pi*sqrt(-1)/n).^((0:m-1)');
         z = d.*yB;
			yT
			z
         y = [yT+z; yT-z]
      end
   end


x = rand(4);
FFTRecur(x);

// Euler method to solve ode

euler = function (fd, x0, x1, y0, n) -> u

dim = length(y0);
h = (x1 - x0) / n;
x = zeros(n + 1, 1);
x[1] = x0;
y = zeros(n + 1, dim);
y[1, :] = y0;

xtemp = x0;
ytemp = y0;

for k = 1 : n
    ytemp += h * fd(xtemp, ytemp);
    xtemp += h;
    x[k] = xtemp;
    y[k + 1, :] = ytemp;
end

u = (x,y);
end

f = (t, x) -> 3 * x * (4 - x)

sol = euler(f, 0, 5, 1.2, 120);


/* --------------------------- */
/* solve quadratic equation */

qsolve = function (a , b, c) -> (x1, x2)
     delta = b * b - 4 * a * c;
     if delta == 0
          x1 = x2 = -0.5 * b / a;
     elseif delta > 0
          if b > 0
               q = -0.5 * (b + sqrt(delta));
          else
               q = -0.5 * (b - sqrt(delta));
          end
          x1 = q / a;
          x2 = c / q;
     else
          x1 = -0.5 * b / a - 0.5 * sqrt(-delta) / a * i;
          x2 = conj(x1);
     end
end

qsolve(1,3,2)
qsolve(1,3,9)
++vv;

// composite Simpson quadrature
compsimpson = function (f, a, b, n) -> s
     h = (b - a) / n;
     hh = h / 2;
     s = f(a) + f(b);
     
     x = a + hh;
     s1 = 0;
     for j = 1 : n
          s1 += f(x);
          x += h;
     end
     s += 4 * s1;

     x = a + h;
     s1 = 0;
     for j = 1 : n - 1
          s1 += f(x);
          x += h;
     end
     s += 2 * s1;

     s *= (h / 6);
end

compsimpson(sin, 0, pi, 128)

++vv;

/* test switch */

whstats = function fn -> T
               file = fopen(fn, "r");
               if file == ()
                   T = ();
                   return;
               end
               T @ "a" = 0;
               T @ "b" = 0;
               T @ "c" = 0;
               T @ "d" = 0;
               T @ "e" = 0;
               T @ "f" = 0;
               T @ "g" = 0;
               T @ "h" = 0;
               T @ "i" = 0;
               T @ "j" = 0;
               T @ "k" = 0;
               T @ "l" = 0;
               T @ "m" = 0;
               T @ "n" = 0;
               T @ "o" = 0;
               T @ "p" = 0;
               T @ "q" = 0;
               T @ "r" = 0;
               T @ "s" = 0;
               T @ "t" = 0;
               T @ "u" = 0;
               T @ "v" = 0;
               T @ "w" = 0;
               T @ "x" = 0;
               T @ "y" = 0;
               T @ "z" = 0;
               T @ "?" = 0;
               while 1
                   line = file.readline()
                   if line == ()
                       break;
                   end
                   words = split(line, " ");
						 
                   for k = 1 : (#words)
                        switch words # k
                            cases ~/^ *[aA]/;
                                T @ "a" = T @ "a" + 1;
                            cases ~/^ *[bB]/;
                                T @ "b" = T @ "b" + 1;
                            cases ~/^ *[cC]/;
                                T @ "c" = T @ "c" + 1;
                            cases ~/^ *[dD]/;
                                T @ "d" = T @ "d" + 1;
                            cases ~/^ *[eE]/;
                                T @ "e" = T @ "e" + 1;
                            cases ~/^ *[fF]/;
                                T @ "f" = T @ "f" + 1;
                            cases ~/^ *[gG]/;
                                T @ "g" = T @ "g" + 1;
                            cases ~/^ *[hH]/;
                                T @ "h" = T @ "h" + 1;
                            cases ~/^ *[iI]/;
                                T @ "i" = T @ "i" + 1;
                            cases ~/^ *[jJ]/;
                                T @ "j" = T @ "j" + 1;
                            cases ~/^ *[kK]/;
                                T @ "k" = T @ "k" + 1;
                            cases ~/^ *[lL]/;
                                T @ "l" = T @ "l" + 1;
                            cases ~/^ *[mM]/;
                                T @ "m" = T @ "m" + 1;
                            cases ~/^ *[nN]/;
                                T @ "n" = T @ "n" + 1;
                            cases ~/^ *[oO]/;
                                T @ "o" = T @ "o" + 1;
                            cases ~/^ *[pP]/;
                                T @ "p" = T @ "p" + 1;
                            cases ~/^ *[qQ]/;
                                T @ "q" = T @ "q" + 1;
                            cases ~/^ *[rR]/;
                                T @ "r" = T @ "r" + 1;
                            cases ~/^ *[sS]/;
                                T @ "s" = T @ "s" + 1;
                            cases ~/^ *[tT]/;
                                T @ "t" = T @ "t" + 1;
                            cases ~/^ *[uU]/;
                                T @ "u" = T @ "u" + 1;
                            cases ~/^ *[vV]/;
                                T @ "v" = T @ "v" + 1;
                            cases ~/^ *[wW]/;
                                T @ "w" = T @ "w" + 1;
                            cases ~/^ *[xX]/;
                                T @ "x" = T @ "x" + 1;
                            cases ~/^ *[yY]/;
                                T @ "y" = T @ "y" + 1;
                            cases ~/^ *[zZ]/;
                                T @ "z" = T @ "z" + 1;
                            default
                                T @ "?" = T @ "?" + 1;
                        end
                   end
               end
               file.close();
          end

T = whstats("readme.txt")


global.covariance = function (x, y) -> v
                  if x in _Dn && y in _Dn && x.length == y.length
                       if x.length == 1
                            v = 0.0;
                       else 
                            v = sum((x - x.mean) .* (y - y.mean)) / (x.length - 1);
                       end
                  else
                       panic("invalid arguments");
                  end
             end

 correlation = (x, y) -> covariance(x, y) / stddev(x) / stddev(y);
              
x = rand(35);
y=rand(35) + 0.01 * rand(35);

correlation(x,y)

++vv;
/* the covariance matrix */


/* covm(x) is the covariance matrix of x, where x is a collection of data of a
 * random vector. Each row of x is an observation of the random vector.
   If x has only one row, a zero vector is returned.
	If x has only one column, the random variable is a scalar instead of vector.
	covm(x) is the same as x.var
 */

global.covm = function x -> v
                   n = x.ncolumns;
                   xc = x - (x.rowmean) * ones(1, n);
                   if n > 1
                        v = xc * xc' / (n - 1);
                   else
                        v = xc * 0.0;
                   end
              end

// function that returns a function
create_func = function d -> func
                  func = function [parm = d] x -> y
                           y = sqrt(x^2 + parm);
                      end
              end

