
jacobi = function [private iterations = 0] (A, b, x0, delta, imax) -> x
     n = b.length;
     x = zeros(n);

     d = A[\];

     for k = 1 : imax
          x = x0 + (b - A * x0) ./ d;
          err = abs(norm(x-x0));
          relerr = err / (norm(x) + eps);
          x0 = x;
          if err < delta || relerr < delta
               break;
          end
     end
     this.iterations = k;
end

gseid = function [private iterations = 0] (A, b, p, delta, imax) -> x
    n = b.length;
    x = p;
    for k = 1 : imax
        for j = 1 : n
             x[j] += (b[j] - A[j, :] * x) / A[j, j];
        end

        err = abs(norm(x-p))
        relerr = err / (norm(x)+eps);
        if err < delta || relerr < delta
            break;
        end
    end
    this.iterations = k;
end

