
/* plot.x
   This is a Shang program designed for scientific plotting and mathematical
	illustration.
	It contains a postscript driver, and several high level classess, including
	2d figure, pie chart, bar graph, and 3d surfaces
	
	Xiaorang Li
 */

/* modify this so that it can detect if newpath has been opened */
global.epspainter = class
             private file;
             public bbox;

             new = function (filename, bbox = [20, 120, 575, 670]) -> ()
                        file = fopen(filename, "w");

                        /* now print the prolog */

                        file.write("%!PS-Adobe-3.0\n");
                        file.write("%% Created by: Shang 1.1\n");
                        file.write("%%");
                        file.printf("BoundingBox: %d %d %d %d\n", bbox[1], bbox[2], bbox[3], bbox[4]); 
                        file.write("%%EndProlog\n\n");
                        file.write("(Helvetica) findfont 15 scalefont setfont\n");
                        
                        file.write("/mto {moveto} def\n");
                        file.write("/lto {lineto} def\n");

                        file.write("/gs {gsave} def\n");
                        file.write("/gr {grestore} def\n");

                        file.write("/setg {setgray} def\n");
                        file.write("/slw {setlinewidth} def\n");
                        file.write("/savlw {/clw currentlinewidth def} def\n");
                        file.write("/sl {cvr ys exch cvr xs exch lto} def\n");
                        file.write("/sm {cvr ys exch cvr xs exch mto} def\n");
                        
                        file.write("/nd {[] 0 setdash} def\n");
                        file.write("/charheight {newpath 0 0 mto (I) false\n");
                        file.write(" charpath flattenpath pathbbox\n");
                        file.write(" exch pop exch sub exch pop newpath} def\n");
                        
                        file.write("/PD {currentlinecap 1 setlinecap 3 1 roll 2 copy moveto lineto stroke setlinecap} def\n");
                        file.write("/dpi2point 2 def\n");
                        file.write("/solid { [] 0 setdash } bind def\n");
                        file.write("/dotty { [.5 dpi2point mul 4 dpi2point mul] 0 setdash } bind def\n");
                        file.write("/dash { [6 dpi2point mul] 0 setdash } bind def\n");
                        file.write("/dashdot { [.5 dpi2point mul 4 dpi2point mul 6 dpi2point mul 4 dpi2point mul] 0 setdash } bind def\n");
                        file.write("1 setlinewidth\n\n");
                   end

             common close = function () -> ()
                                 parent.file.close();
                            end

             common moveto = function (x, y) -> ()
                                 parent.file.printf("%g %g mto\n", x, y);
                             end 

             common lineto = function (x, y) -> ()
                                 parent.file.printf("%g %g lto\n", x, y);
                             end 

             common rlineto = function (x, y) -> ()
                                  parent.file.printf("%g %g rlineto\n", x, y);
                             end 


             common scale = function (kx, ky) -> ()
                                  parent.file.printf("%g %g scale\n", kx, ky);
                            end 

             common translate = function (dx, dy) -> ()
                                  parent.file.printf("%g %g translate\n", dx, dy);
                             end 

             common rotate = function theta -> ()
                                  parent.file.printf("%g rotate\n", theta);
                             end 

             common show = function str -> ()
                                  parent.file.printf("(%s) show\n", str);
                             end 

             common setfont = function (fontname, height) -> ()
                                  parent.file.printf("/%s findfont %d scalefont setfont\n", fontname, height);
                              end 

             common arc = function (x, y, r, theta0, theta1) -> ()
                                 parent.file.printf("%g %g %g %g %g arc\n", x, y, r, theta0, theta1);
                            end

             common arcn = function (x, y, r, theta0, theta1) -> ()
                                 parent.file.printf("%g %g %g %g %g arcn\n", x, y, r, theta0, theta1);
                            end

             common arcto = function (x1, y1, x2, y2, r) -> ()
                                 parent.file.printf("%g %g %g %g %g arcto\n", x1, y1, x2, y2, r);
                            end

             common curveto = function (x1, y1, x2, y2, x3, y3) -> ()
                                 parent.file.printf("%g %g %g %g %g %g curveto\n", x1, y1, x2, y2, x3, y3);
                              end

             common drawdot = function (x, y, r) -> ()
                                 parent.file.printf("newpath %g %g %g 0 360 arc fill\n", x, y, r);
                              end

             common drawcircle = function (x, y, r) -> ()
                                 parent.file.printf("newpath %g %g %g 0 360 arc stroke\n", x, y, r);
                              end

             common drawsquare = function (x, y, w) -> ()
                                 parent.moveto(x - w / 2, y - w / 2);
                                 parent.rlineto(w, 0);
                                 parent.rlineto(0, w);
                                 parent.rlineto(-w, 0);
                                 parent.closepath();
                                 parent.stroke();
                              end

             common drawutriangle = function (x, y, w) -> ()
                                 parent.moveto(x, y + 2 / 3 * w);
                                 parent.rlineto(-w / 2, - sqrt(3) / 2 * w);
                                 parent.rlineto(w, 0);
                                 parent.closepath();
                                 parent.stroke();
                              end

             common drawdtriangle = function (x, y, w) -> ()
                                 parent.moveto(x, y - 2 / 3 * w);
                                 parent.rlineto(w / 2, sqrt(3) / 2 * w);
                                 parent.rlineto(-w, 0);
                                 parent.closepath();
                                 parent.stroke();
                              end

             common drawflake = function (x, y, w) -> ()
                                 parent.moveto(x - w, y);
                                 parent.rlineto(2 * w, 0);
                                 parent.moveto(x - w / 2, y - w * sqrt(3) / 2);
                                 parent.rlineto(w, sqrt(3) * w);

                                 parent.moveto(x + w / 2, y - w * sqrt(3) / 2);
                                 parent.rlineto(-w, sqrt(3) * w);
                                 parent.stroke();
                              end

             common drawasterisk = function (x, y, R) -> ()
                                 
                                 parent.moveto(x, y);
                                 parent.rlineto(0, R);
                                 parent.moveto(x, y);
                                 parent.rlineto(-R * sin(72 / 180 * pi), R * cos(72 / 180 * pi));
                                 parent.moveto(x, y);
                                 parent.rlineto(R * sin(72 / 180 * pi), R * cos(72 / 180 * pi));
                                 parent.moveto(x, y);
                                 parent.rlineto(-R * sin(36 / 180 * pi), -R * cos(36 / 180 * pi));
                                 parent.moveto(x, y);
                                 parent.rlineto(R * sin(36 / 180 * pi), -R * cos(36 / 180 * pi));

                                 parent.stroke();
                              end

             common drawdiamond = function (x, y, v, h) -> ()
                                 parent.setlinetype("solid");
                                 parent.moveto(x - h / 2, y);
                                 parent.rlineto(h / 2, -(v / 2));
                                 parent.rlineto(h / 2, v / 2);
                                 parent.rlineto(-(h / 2), v / 2);
                                 parent.closepath();
                                 parent.stroke();
                              end

             common drawstar = function (x, y, R) -> ()
                                 a = R * sin(126 * pi / 180);
                                 parent.setlinetype("solid");
                                 parent.moveto(x, y + R);
                                 parent.rlineto(-a * sin(0.1 * pi), -a * cos(0.1 * pi));
                                 parent.rlineto(-a, 0);
                                 parent.rlineto(a * cos(0.2 * pi), -a * sin(0.2 * pi));
                                 parent.rlineto(-a * sin(0.1 * pi), -a * cos(0.1 * pi));
                                 parent.rlineto(a * cos(0.2 * pi), a * sin(0.2 * pi));

                                 parent.rlineto(a * cos(0.2 * pi), -a * sin(0.2 * pi));
                                 parent.rlineto(-a * sin(0.1 * pi), a * cos(0.1 * pi));

                                 parent.rlineto(a * cos(0.2 * pi), a * sin(0.2 * pi));

                                 parent.rlineto(-a, 0);

                                 parent.closepath();
                                 parent.stroke();
                              end

             common drawoval = function (x, y, a, b) -> ()
                                 parent.gsave();
                                 parent.setlinetype("solid");
                                 parent.translate(x, y);
                                 parent.scale(1, b / a);
                                 parent.arc(0, 0, a, 0, 360);
                                 parent.stroke();
                                 parent.grestore();
                              end

             common drawplus = function (x, y, a) -> ()
                                 parent.setlinetype("solid");
                                 parent.moveto(x, y + a / 2);
                                 parent.rlineto(0, -a);
                                 parent.moveto(x - a / 2, y);
                                 parent.rlineto(a, 0);
                                 parent.stroke();
                              end

             common drawcross = function (x, y, a) -> ()
                                 parent.setlinetype("solid");
                                 parent.moveto(x - a / 2, y + a / 2);
                                 parent.rlineto(a, -a);
                                 parent.moveto(x - a / 2, y - a / 2);
                                 parent.rlineto(a, a);
                                 parent.stroke();
                              end



             common newpath = function () -> ()
                                 parent.file.write("newpath\n");
                            end

             common closepath = function () -> ()
                                 parent.file.write("closepath\n");
                            end

             common stroke = function () -> ()
                                 parent.file.write("stroke\n");
                            end

             common fill = function () -> ()
                                 parent.file.write("fill\n");
                           end

             common clip = function () -> ()
                                 parent.file.write("clip\n");
                           end

             common drawbox = function (llx, lly, w, h, fillcolor) -> ()
                                   parent.newpath();
                                   parent.moveto(llx, lly);
                                   parent.rlineto(w, 0);
                                   parent.rlineto(0, h);
                                   parent.rlineto(-w, 0);
                                   parent.closepath();
                                   if fillcolor == []
                                        parent.stroke();
                                   else
                                        parent.gsave();
                                        parent.stroke();
                                        parent.grestore();
                                        parent.gsave();
                                        parent.setrgbcolor(fillcolor[1], fillcolor[2], fillcolor[3]); 
                                        parent.fill();
                                        parent.grestore();
                                   end
                                        
                              end

             /* arrow points from (x0, y0) to (x1, y1), but don't draw line from
				  * (x0, y0) to (x1, y1) */

             common drawarrow = function (x0, y0, x1, y1, arrow_len, arrow_angle, base_angle) -> ()
                                   r = norm([x0 - x1, y0 - y1]);
                                   alpha = asin(abs(y1 - y0) / r);

                                   if x0 >= x1
                                        if y0 >= y1
                                            theta = alpha;
                                        else
                                            theta = -alpha;
                                        end
                                   else
                                        if y0 >= y1
                                            theta = pi - alpha;
                                        else
                                            theta = pi + alpha;
                                        end
                                   end

                                   parent.newpath();
                                   parent.gsave();

                                   parent.translate(x1, y1);
                                   parent.rotate(theta * 180 / pi);

                                   h = arrow_len * tan(arrow_angle / 2);
                                   dw = h / tan(base_angle / 2);
                                   parent.moveto(0, 0);
                                   parent.lineto(arrow_len, h);
                                   parent.rlineto(-dw, -h);
                                   parent.rlineto(dw, -h);
                                   parent.closepath();
                                   parent.fill();
                                   parent.grestore();
                                 end


             common showHorText = function (xcenter, ycenter, text) -> ()
                                     parent.newpath();
                                     parent.file.printf("\n%d %d moveto\n", xcenter, ycenter);
                                     parent.file.printf("(%s) stringwidth pop 2 div\n", text);
                                     parent.file.printf("%d cvr exch sub ", xcenter); 
                                     
                                     parent.file.printf("%d charheight 2 div sub ", ycenter);
                                     parent.file.printf("moveto (%s) show\n", text);
                               end   

             common showVerText = function (rightlimit, ycenter, text) -> ()
                                     parent.gsave();
                                     parent.newpath();
                                     parent.translate(rightlimit, ycenter);
                                     parent.rotate(90);
                                     parent.showHorText(0, 0, text);
                                     parent.grestore();
                                  end

             common showBottomAlignedText = function (rightlimit, ycenter, text) -> ()
                                     parent.gsave();
                                     parent.newpath();
                                     parent.translate(rightlimit, ycenter);
                                     parent.rotate(90);
                                     parent.showLeftAlignedText(0, 0, text);
                                     parent.grestore();
                                  end

             common showTopAlignedText = function (rightlimit, ycenter, text) -> ()
                                     parent.gsave();
                                     parent.newpath();
                                     parent.translate(rightlimit, ycenter);
                                     parent.rotate(90);
                                     parent.showRightAlignedText(0, 0, text);
                                     parent.grestore();
                                  end


             common showRightAlignedText = function (rightlimit, ycenter, text) -> ()
                                     parent.newpath();
                                     parent.file.printf("\n%d %d moveto\n", rightlimit, ycenter);
                                     
                                     parent.file.printf("%d (%s) stringwidth pop sub\n", rightlimit, text);
                                     
                                     parent.file.printf("%d charheight ", ycenter);
                                     parent.file.printf("2 div sub moveto ");
                                     parent.file.printf("(%s) show\n", text);

                                  end

             common showLeftAlignedText = function (leftlimit, ycenter, text) -> ()
                                     parent.newpath();
                                     /*parent.file.printf("\n%d %d moveto\n",
												  * leftlimit, ycenter);*/

                                     parent.file.printf("\n%d %d charheight 2 div sub moveto\n", leftlimit, ycenter);
                                     
                                     parent.file.printf("(%s) show\n", text);

                                  end


             common gsave = function () -> ()
                                 parent.file.write("gs\n");
                            end

             common grestore = function () -> ()
                                 parent.file.write("gr\n");
                            end

             common setgray = function g -> ()
                                 parent.file.printf("%g setgray\n", g); 
                              end

             common setrgbcolor = function (r, g, b) -> ()
                                 parent.file.printf("%g %g %g setrgbcolor\n", r, g, b); 
                              end

             common setlinewidth = function w -> ()
                                 parent.file.printf("%g setlinewidth\n", w); 
                              end

             common setlinecap = function x -> ()
                                 parent.file.printf("%d setlinecap\n", x); 
                              end

             common setlinejoin = function x -> ()
                                 parent.file.printf("%d setlinejoin\n", x); 
                              end

             common setdash = function p -> ()
                                 parent.file.printf("%s setdash\n", p);
                              end
             common setlinetype = function lt -> ()
                                       parent.file.write(lt);
                                       parent.file.write("\n");
                                   end
     end


global.colors = {
     black = [0, 0, 0],
     gray = [0.5, 0.5, 0.5],
	  silver = [0.75, 0.75, 0.75],
     white = [1, 1, 1],
     yellow = [1, 1, 0],
	  lime = [0, 1, 0],
	  aqua = [0, 1, 1],
	  fuchsia = [1, 0, 1],
     red = [1, 0, 0],
     green = [0, 0.5, 0],
     blue = [0, 0, 1],
     purple = [0.5,  0, 0.5],
	  maroon = [0.5, 0, 0],
	  olive = [0.5, 0.5, 0],
	  navy = [0, 0, 0.5],
	  teal = [0, 0.5, 0.5]
};


global.scale_trans = [kx, ky, bx, by] xy -> xy .* [kx, ky] + [bx, by];


global.findTick = function range -> ticks
                         span = range[2] - range[1];
                         lo = floor(log10(span));
                        
                         ex = 10.0 ^ lo;
                         
                         man = span / ex;
                        
                         if (man <= 1.5)
                              tickspac = 0.25 * ex;
                         elseif (man <= 3)
                              tickspac = 0.5 * ex;
                         elseif (man <= 6)
                              tickspac = ex;
                         else
                              tickspac = 2 * ex;
                         end

                         tick0 = ceil(range[1] / tickspac) * tickspac;

                         ticks = tick0 : tickspac : range[2];
                  end

global.Path = class 
            public marker = "solid" in {"solid", "dotty", "dash", "dashdot"};
            public width = 1 in _R;  /* it's a factor */
            public color = [1, 1, 1];
            public gray = 1;
            public closed = 0;

            public x = 1;
            public y = 1;

            new = (x, y, marker, width, color, gray) -> ();

            auto xrange = () -> [min(parent.x), max(parent.x)]; 
            auto yrange = () -> [min(parent.y), max(parent.y)]; 

            common draw = function (pen, coord_trans) -> ()
                       x = parent.x;
                       y = parent.y;
                  
                       xyt_prev = []; 
                       pen.gsave();

                       if parent.color != [1, 1, 1]
                            pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                       end

                       if parent.gray != 1
                            pen.setgray(parent.gray);
                       end

                       pen.newpath();
                       pen.setlinetype(parent.marker);

                       pen.setlinewidth(parent.width);

                       for j = 1 : x.length
                           xyt = coord_trans([x[j], y[j]]);
                  
                           if xyt == xyt_prev
                                continue;
                           end
                           xyt_prev = xyt;
                 
                           if j > 1
                               pen.lineto(xyt[1], xyt[2]); 
                           else
                               pen.moveto(xyt[1], xyt[2]); 
                           end
                       end

                       if parent.closed == 1
                            pen.closepath();
                       end

                       pen.stroke();
                       pen.grestore();
                 end
       end


global.Curve = class 
            public marker = "solid" in {"solid", "dotty", "dash", "dashdot"};
            public width = 1 in _R;  /* it's a factor */
            public color = [1, 1, 1];
            public gray = 1;

            public arrowlen = 111555;
            public arrowangle = pi / 6;
            public arrowbaseangle = pi / 2;

            public style = "-" in {"-", "->", "<-", "<->"};

            public x = 1;
            public y = 1;

            /* this is not quite right, the range might be beyond
				   the range of the knots
					will redo later
             */
            auto xrange = () -> [min(parent.x), max(parent.x)]; 
            auto yrange = () -> [min(parent.y), max(parent.y)]; 

            new = (x, y, marker, width, color, gray) -> ();

            common draw = function (pen, coord_trans) -> ()
                       x = parent.x;
                       y = parent.y;

                       n = y.length;
                  
                       if n <= 1
                            return;
                       end

                       pen.gsave();

                       if parent.color != [1, 1, 1]
                            pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                       end

                       if parent.gray != 1
                            pen.setgray(parent.gray);
                       end

                       pen.newpath();
                       pen.setlinetype(parent.marker);
                       pen.setlinewidth(parent.width);

                       s = zeros(n, 1);

                       s[1] = 0;
                       for k = 2 : n
                            s[k] = s[k - 1] + norm([x[k], y[k]] - [x[k - 1], y[k - 1]]);
                       end

                       if x[1] == x[n] && y[1] == y[n]
                            pswx = splinefit(s, x, "cyclic");
                            coeffx = pswx.coeff;
                            
                            pswy = splinefit(s, y, "cyclic");
                            coeffy = pswy.coeff;
                       else
                            pswx = splinefit(s, x);
                            coeffx = pswx.coeff;
                            
                            pswy = splinefit(s, y);
                            coeffy = pswy.coeff;
                       end

                       xyt = coord_trans([x[1], y[1]]);
                       pen.moveto(xyt[1], xyt[2]);
                       for j = 2 : x.length
                           ax = coeffx[j - 1, 1];
                           bx = coeffx[j - 1, 2];
                           cx = coeffx[j - 1, 3];
                           dx = coeffx[j - 1, 4];

                           ay = coeffy[j - 1, 1];
                           by = coeffy[j - 1, 2];
                           cy = coeffy[j - 1, 3];
                           dy = coeffy[j - 1, 4];

                           DS = s[j] - s[j - 1];

                           P3 = coord_trans([x[j], y[j]]);

                           P1 = coord_trans([x[j - 1] + DS / 3 * bx, y[j - 1] + DS / 3 * by]);

                           P2x = x[j] - DS / 3 * (bx + DS * (2 * cx + 3 * dx * DS));
                           P2y = y[j] - DS / 3 * (by + DS * (2 * cy + 3 * dy * DS));

                           P2 = coord_trans([P2x, P2y]);
                 
                           pen.curveto(P1[1], P1[2], P2[1], P2[2], P3[1], P3[2]);

                       end
                       pen.stroke();


                       if parent.style == "<-" || parent.style == "<->"
                           ax = coeffx[1, 1];
                           bx = coeffx[1, 2];
                           cx = coeffx[1, 3];
                           dx = coeffx[1, 4];

                           ay = coeffy[1, 1];
                           by = coeffy[1, 2];
                           cy = coeffy[1, 3];
                           dy = coeffy[1, 4];

                           DS = s[2] - s[1];

                           P1 = coord_trans([x[1] + DS / 3 * bx, y[1] + DS / 3 * by]);

                           pen.drawarrow(P1[1], P1[2], xyt[1], xyt[2], parent.arrowlen, parent.arrowangle, parent.arrowbaseangle);
                       end
                       if parent.style == "->" || parent.style == "<->"
                           pen.drawarrow(P2[1], P2[2], P3[1], P3[2], parent.arrowlen, parent.arrowangle, parent.arrowbaseangle);
                       end
                       
                       pen.grestore();
                 end
       end


global.Text = class
                  public x = 0 in _R;
                  public y = 0 in _R;
                  public content = "" in _string;
                  public orientation = "portrait" in {"portrait", "landscape"};
                  public alignment = "left" in {"left", "right", "center", "top", "bottom"};
                  public font = "Helvetica" in {"Times", "Helvetica", "Courier", "Symbol"};
                  public fontstyle = "Regular" in {"Regular", "Bold", "Italic", "BoldItalic"};
                  public fontscale = 2;
                  public color = [0, 0, 0];

                  /* certainly wrong, but I'm not sure how to determine the
						 * length and height of a string ... yet
                   */
                  auto xrange = () -> [parent.x, parent.x]; 
                  auto yrange = () -> [parent.y, parent.y]; 

                  new = (x, y, content, orientation, alignment, color, font, fontstyle, fontscale) -> ();

                  public makefontname = function () -> fontname
                                             if parent.fontstyle == "Regular" || parent.font == "Symbol"
                                                  fontname = parent.font;
                                             else
                                                  fontname = parent.font + "-" + parent.fontstyle;
                                             end
                                         end

                  common draw = function (pen, coord_trans) -> ()
                       pen.gsave();
                       pen.setfont(parent.makefontname(), parent.fontscale * 15);
                       pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                       xyt = coord_trans([parent.x, parent.y]);
                       if parent.orientation == "portrait"
                            if parent.alignment == "right"
                                 pen.showRightAlignedText(xyt[1], xyt[2], parent.content); 
                            elseif parent.alignment == "left" 
                                 pen.showLeftAlignedText(xyt[1], xyt[2], parent.content); 
                            else
                                 pen.showHorText(xyt[1], xyt[2], parent.content);
                            end
                       else
                            if parent.alignment == "top"
                                 pen.showTopAlignedText(xyt[1], xyt[2], parent.content);
                            elseif parent.alignment == "bottom"
                                 pen.showBottomAlignedText(xyt[1], xyt[2], parent.content);
                            else
                                 pen.showVerText(xyt[1], xyt[2], parent.content);
                            end
                       end
                       pen.grestore();
                  end

              end


global.bezier = class 
            public marker = "solid" in {"solid", "dotty", "dash", "dashdot"};
            public width = 1 in _R;  /* it's a factor */
            public color = [1, 1, 1];
            public gray = 1;

            public p0;
            public p1;
            public p2;
            public p3;

            auto xrange = () -> [parent.P0[1], parent.P3[1]]; 
            auto yrange = () -> [parent.P0[2], parent.P3[2]]; 

            new = (p0, p1, p2, p3, marker, width, color, gray) -> ();

            common draw = function (pen, coord_trans) -> ()
                       pen.gsave();

                       if parent.color != [1, 1, 1]
                            pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                       end

                       if parent.gray != 1
							  "bezier set gray"
                            pen.setgray(parent.gray);
                       end

                       pen.newpath();
                       pen.setlinetype(parent.marker);

                       pen.moveto(parent.p0[1], parent.p0[2]);
                       pen.curveto(parent.p1[1], parent.p1[2], parent.p2[1], parent.p2[2], parent.p3[1], parent.p3[2]);

                       pen.stroke();
                       pen.grestore();
                 end
       end



/* markers: circle, triangle, square, diamond, star, cross, asterisk ... */

global.Dots = class 
            public marker = "dot" in {"dot", "oval", "circle", "square", "diamond", "star", "flake", "asterisk", "utriangle", "dtriangle", "cross", "plus"};
            public size = 1 in _R;  /* it's a factor */
            public size_2 = 1;
            public solid = 1;

            public color = [1, 1, 1];
            public gray = 1;

            public x = 1;
            public y = 1;

            auto xrange = () -> [min(parent.x), max(parent.x)]; 
            auto yrange = () -> [min(parent.y), max(parent.y)]; 

            new = function (x, y, marker, size, color, gray) -> ()
                            if marker == "diamond" || marker == "oval"
                                 if size.length == 2
                                     size_2 = size[2];
                                     size = size[1];
                                 elseif size.length == 1
                                     size_2 = size;
                                 else
                                     panic("invalid parameters");
                                 end
                            elseif size.length != 1
                                     panic("invalid parameters");
                            end
                  end

            common draw = function (pen, coord_trans) -> ()
                       x = parent.x;
                       y = parent.y;
                  
                       xyt_prev = []; 
                       pen.gsave();

                       if parent.gray != 1
							  "dots set gray"
                            pen.setgray(parent.gray);
                       end

                       if parent.color != [1, 1, 1]
                            pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                       end

                       pen.newpath();
                       switch parent.marker
                            case "dot"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawdot(xyt[1], xyt[2], parent.size);
                                 end
                            case "circle"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawcircle(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "diamond"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawdiamond(xyt[1], xyt[2], parent.size * 7, parent.size_2 * 5);
                                 end

                            case "oval"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawoval(xyt[1], xyt[2], parent.size * 5, parent.size_2 * 3);
                                 end


                            case "square"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawsquare(xyt[1], xyt[2], parent.size * 4);
                                 end

                            case "star"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawstar(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "asterisk"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawasterisk(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "utriangle"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawutriangle(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "dtriangle"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawdtriangle(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "cross"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawcross(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "plus"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawplus(xyt[1], xyt[2], parent.size * 4);
                                 end
                            case "flake"
                                 for j = 1 : x.length
                                      xyt = coord_trans([x[j], y[j]]);
                                      if xyt == xyt_prev
                                           continue;
                                      end
                                      xyt_prev = xyt;
                                      pen.drawflake(xyt[1], xyt[2], parent.size * 4);
                                 end
                       end

                       pen.stroke();
                       pen.grestore();
                 end
       end


global.Polygon = class
            public x = [];
            public y = [];
            public type = "contour" in {"contour", "solid"};
            public color = [1, 1, 1];

            auto xrange = () -> [min(parent.x), max(parent.x)]; 
            auto yrange = () -> [min(parent.y), max(parent.y)]; 

            new = function (x, y, type, color) -> ()
                       if x.length != y.length
                            panic("x and y coordinate vectors don't equal in length");
                       end
                  end
            
            common draw = function (pen, coord_trans) -> ()
                              x = parent.x;
                              y = parent.y;

//                              pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                              pen.setrgbcolor(0, 0, 0);
                              
                              xyt = coord_trans([x[1], y[1]]);
                              pen.moveto(xyt[1], xyt[2]);

                              for k = 2 : x.length
                                   xyt = coord_trans([x[k], y[k]]);
                                   pen.lineto(xyt[1], xyt[2]);
                              end
                              
                              pen.closepath();
                              pen.gsave();
                              pen.stroke();

                              if parent.type == "solid"
                                   pen.grestore();
                              pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                                   pen.fill();
                              end

              end
       end


global.Rectangle = class
            public ox = 0 in _R;
            public oy = 0 in _R;
            public width = 1 in _R;
            public height = 1 in _R;
            public style = "plain" in {"plain", "rounded", "beveled"};
            public cornersize = 1 ;
            public type = "contour" in {"contour", "solid"};
            public color = [1, 1, 1];

            auto xrange = () -> [parent.ox - parent.width / 2, parent.ox + parent.width / 2]; 
            auto yrange = () -> [parent.oy - parent.height / 2, parent.oy + parent.height / 2]; 

            new = (ox, oy, width, height, style, cornersize, type, color) -> ();
            
            common draw = function (pen, coord_trans) -> ()
                              ox = parent.ox;
                              oy = parent.oy;
                              w  = parent.width;
                              h  = parent.height;
                              if parent.style == "plain"
                                   pen.newpath();
                                   xyt = coord_trans([ox - w / 2, oy - h / 2]);
                                   pen.moveto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox + w / 2, oy - h / 2]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox + w / 2, oy + h / 2]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox - w / 2, oy + h / 2]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   pen.closepath();
                              elseif parent.style == "rounded"
                                   R = parent.cornersize;
                                   pen.newpath();

                                   xyt = coord_trans([ox, oy]);
                                   oxt = xyt[1];
                                   oyt = xyt[2];
                                   xyt = coord_trans([ox + w / 2, oy + h / 2]);
                                   wht = xyt[1] - oxt;
                                   hht = xyt[2] - oyt;
                                   xyt = coord_trans([ox + R, oy]);
                                   Rt = xyt[1] - oxt;

                                   pen.arc(oxt + wht - Rt, oyt - hht + Rt, Rt, -90, 0);
                                   pen.arc(oxt + wht - Rt, oyt + hht - Rt, Rt, 0, 90);
                                   pen.arc(oxt - wht + Rt, oyt + hht - Rt, Rt,
											  90.22, 180.353);
                                   pen.arc(oxt - wht + Rt, oyt - hht + Rt, Rt, 180, 270);

                                   pen.closepath();
                              elseif parent.style == "beveled"
										"cornersize is"
										parent.cornersize
                                   a = parent.cornersize[1];
                                   b = parent.cornersize[2];
                                   pen.newpath();
                                   xyt = coord_trans([ox - w / 2 + a, oy - h / 2]);
                                   pen.moveto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox + w / 2 - a, oy - h / 2]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox + w / 2, oy - h / 2 + b]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox + w / 2, oy + h / 2 - b]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox + w / 2 - a, oy + h / 2 ]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox - w / 2 + a, oy + h / 2 ]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox - w / 2, oy + h / 2 - b]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   xyt = coord_trans([ox - w / 2, oy - h / 2 + b]);
                                   pen.lineto(xyt[1], xyt[2]); 
                                   pen.closepath();
                              end

                              pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);

                              if parent.type == "solid"
                                   pen.fill();
                              else
                                   pen.stroke();
                              end
              end
       end


global.Line = class
            public P0;
            public P1;
            public arrowlen = 15 in _R;
            public arrowangle = pi / 6 in _R;
            public arrowbaseangle = pi / 2 in _R;
            public style = "-" in {"-", "->", "<-", "<->"};
            public linetype = "solid" in {"solid", "dotty"};
            public linewidth = 3 in _R;
            public color = [0, 0, 0];

            auto xrange = function () -> xr
                               if parent.P0[1] <= parent.P1[1]
                                    xr = [parent.P0[1], parent.P1[1]];
                               else
                                    xr = [parent.P1[1], parent.P0[1]];
                               end
                          end

            auto yrange = function () -> xr
                               if parent.P0[2] <= parent.P1[2]
                                    xr = [parent.P0[2], parent.P1[2]];
                               else
                                    xr = [parent.P1[2], parent.P0[2]];
                               end
                          end


            new = (P0, P1, style, linetype, linewidth, color) -> ();
            
            common draw = function (pen, coord_trans) -> ()
                              pen.setlinewidth(parent.linewidth);
                              pen.setlinetype(parent.linetype);
                              pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);
                              P0 = parent.P0;
                              P1 = parent.P1;
                              xyt = coord_trans(P0);
                              xt1 = xyt[1];
                              yt1 = xyt[2];

                              xyt = coord_trans(P1);
                              xt2 = xyt[1];
                              yt2 = xyt[2];

                              pen.newpath();
                              pen.moveto(xt1, yt1);
                              pen.lineto(xt2, yt2);
                              pen.stroke();

                              if parent.style == "->"
                                   pen.drawarrow(xt1, yt1, xt2, yt2, parent.arrowlen, parent.arrowangle, parent.arrowbaseangle);
                              elseif parent.style == "<-"
                                   pen.drawarrow(xt2, yt2, xt1, yt1, parent.arrowlen, parent.arrowangle, parent.arrowbaseangle);
                              elseif parent.style == "<->"
                                   pen.drawarrow(xt1, yt1, xt2, yt2, parent.arrowlen, parent.arrowangle, parent.arrowbaseangle);
                                   pen.drawarrow(xt2, yt2, xt1, yt1, parent.arrowlen, parent.arrowangle, parent.arrowbaseangle);
                              end
              end
       end


global.Ellipse = class
            public ox = 0 in _R;
            public oy = 0 in _R;
            public a = 1 in _R;
            public b = 1 in _R;
            public theta = 0 in _R;
            public type = "contour" in {"contour", "solid"};
            public color = [0, 0, 0];

            auto xrange = function () -> r
                               a = parent.a;
                               b = parent.b;
                               theta = parent.theta;
                               x = parent.ox;
                               y = parent.oy;
                               if theta == 0
                                    r = [x - a, x + a];
                               else
                                    m = norm([a * cos(theta), b * sin(theta)]); 
                                    r = [x - m, x + m];
                               end
                          end

            auto yrange = function () -> r
                               a = parent.a;
                               b = parent.b;
                               theta = parent.theta;
                               x = parent.ox;
                               y = parent.oy;
                               if theta == 0
                                    r = [y - b, y + b];
                               else
                                    m = norm([a * sin(theta), b * cos(theta)]); 
                                    r = [y - m, y + m];
                               end
                          end

            new = (ox, oy, a, b, theta, type, color) -> ();
            
            common draw = function (pen, coord_trans) -> ()
                              N = 16;
                              x = zeros(N + 1, 1);
                              y = zeros(N + 1, 1);
                              
                              dphi = 2 * pi / N;
                              phi = 0;

                              theta = parent.theta;
                              a = parent.a;
                              b = parent.b;
                              ox = parent.ox;
                              oy = parent.oy;
                              if theta == 0
                                   for k = 1 : N
                                        xt = a * cos(phi);
                                        yt = b * sin(phi);
                                        x[k] = ox + xt;
                                        y[k] = oy + yt;
                                        phi += dphi;
                                   end
                              else
                                   for k = 1 : N
                                        xt = a * cos(phi);
                                        yt = b * sin(phi);
                                        x[k] = ox + xt * cos(theta) - yt * sin(theta);
                                        y[k] = oy + xt * sin(theta) + yt * cos(theta);
                                        phi += dphi;
                                   end
                              end

                              x[N + 1] = x[1];
                              y[N + 1] = y[1];

                              s = zeros(N + 1, 1);
                              s[1] = 0;
                              for k = 2 : N + 1
                                   s[k] = s[k - 1] + norm([x[k], y[k]] - [x[k - 1], y[k - 1]]);
                              end
                              
                              pswx = splinefit(s, x, "cyclic");
                              coeffx = pswx.coeff;
                              
                              pswy = splinefit(s, y, "cyclic");
                              coeffy = pswy.coeff;
                              
                              xyt = coord_trans([x[1], y[1]]);

                              pen.newpath();
                              pen.moveto(xyt[1], xyt[2]);
                              
                              for j = 2 : N + 1
                                  ax = coeffx[j - 1, 1];
                                  bx = coeffx[j - 1, 2];
                                  cx = coeffx[j - 1, 3];
                                  dx = coeffx[j - 1, 4];
                              
                                  ay = coeffy[j - 1, 1];
                                  by = coeffy[j - 1, 2];
                                  cy = coeffy[j - 1, 3];
                                  dy = coeffy[j - 1, 4];
                              
                                  DS = s[j] - s[j - 1];
                              
                                  P3 = coord_trans([x[j], y[j]]);
                              
                                  P1 = coord_trans([x[j - 1] + DS / 3 * bx, y[j - 1] + DS / 3 * by]);
                              
                                  P2x = x[j] - DS / 3 * (bx + DS * (2 * cx + 3 * dx * DS));
                                  P2y = y[j] - DS / 3 * (by + DS * (2 * cy + 3 * dy * DS));
                              
                                  P2 = coord_trans([P2x, P2y]);
                              
                                  pen.curveto(P1[1], P1[2], P2[1], P2[2], P3[1], P3[2]);
                              
                              end

                              pen.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);

                              if parent.type == "solid" 
                                   pen.fill();
                              else
                                   pen.stroke();
                              end
              end
       end


/* x and y are the ranges */

global.figurebox = class 
            public x = 1;
            public y = 1;
            public llx = 0;
            public lly = 0;
            public fw = 1;
            public fh = 1;
            public xlabel = "";
            public ylabel = "";
            public xticklen = 6;
            public yticklen = 6;
            public grided = 0;

            new = (x, y, llx, lly, fw, fh, xlabel, ylabel, grided) -> ();


            common draw = function (pen, coord_trans) -> ()
                       llx = parent.llx;
                       lly = parent.lly;
                       fw = parent.fw;
                       fh = parent.fh;
                       xticklen = parent.xticklen;
                       yticklen = parent.yticklen;
                       pen.drawbox(llx, lly, fw, fh, []);

                       if parent.grided
                           pen.setlinetype("dotty");
                           xticks = findTick(parent.x);
                           for k = 1 : length(xticks)
                                pen.newpath();
                                xyt = coord_trans([xticks[k], 0]);
                                pen.moveto(xyt[1], lly);
                                pen.rlineto(0, fh);
                                pen.stroke();
                                pen.showHorText(xyt[1], lly - 12, sprintf("%g", xticks[k]));
                           end

                           yticks = findTick(parent.y);
                           for k = 1 : length(yticks)
                                pen.newpath();
                                xyt = coord_trans([0, yticks[k]]);
                                pen.moveto(llx, xyt[2]);
                                pen.rlineto(fw, 0);
                                pen.stroke();
                                pen.showRightAlignedText(llx - 5, xyt[2], sprintf("%g", yticks[k]));
                           end
                           pen.setlinetype("solid");
                       else
                            xticks = findTick(parent.x);
                            for k = 1 : length(xticks)
                                 pen.newpath();
                                 xyt = coord_trans([xticks[k], 0]);
                                 pen.moveto(xyt[1], lly);
                                 pen.rlineto(0, xticklen);
                                 pen.moveto(xyt[1], lly + fh);
                                 pen.rlineto(0, -xticklen);
                                 pen.stroke();
                                 pen.showHorText(xyt[1], lly - 12, sprintf("%g", xticks[k]));
                            end
                            
                            yticks = findTick(parent.y);
                            for k = 1 : length(yticks)
                                 pen.newpath();
                                 xyt = coord_trans([0, yticks[k]]);
                                 pen.moveto(llx, xyt[2]);
                                 pen.rlineto(yticklen, 0);
                                 pen.moveto(llx + fw, xyt[2]);
                                 pen.rlineto(-yticklen, 0);
                                 pen.stroke();
                                 pen.showRightAlignedText(llx - 5, xyt[2], sprintf("%g", yticks[k]));
                            end
                       end

                       if parent.ylabel != ""
                            pen.showVerText (llx - 35, lly + fh / 2, parent.ylabel);

                       end

                       if parent.xlabel != ""
                            pen.showHorText(llx + fw / 2, lly - 27, parent.xlabel);
                       end

                 end
       end

global.figureaxis = class 
            public x = 1;
            public y = 1;
            public llx = 0;
            public lly = 0;
            public fw = 1;
            public fh = 1;
            public xlabel = "";
            public ylabel = "";
            public xticklen = 6;
            public yticklen = 6;

            new = (x, y, llx, lly, fw, fh, xlabel, ylabel, grided) -> ();

            common draw = function (pen, coord_trans) -> ()
                       x_range = parent.x;
                       y_range = parent.y;
                       llx = parent.llx;
                       lly = parent.lly;
                       fw = parent.fw;
                       fh = parent.fh;
                       xticklen = parent.xticklen;
                       yticklen = parent.yticklen;

                       if x_range[1] <= 0 && x_range[2] >= 0 && y_range[1] <= 0 && y_range[2] >= 0
                            oxy = coord_trans([0, 0]); 
                       else
                            oxy = coord_trans([x_range[1], y_range[1]]); 
                       end

                       pen.moveto(llx, oxy[2]);
                       pen.rlineto(fw + 25, 0);
                       pen.stroke();

                       pen.drawarrow(llx, oxy[2], llx + fw + 25, oxy[2], 15, pi / 6, pi / 2);

                       pen.moveto(oxy[1], lly);
                       pen.rlineto(0, fh + 25);
                       pen.stroke();

                       pen.drawarrow(oxy[1], lly, oxy[1], lly + fh + 25, 15, pi / 6, pi / 2);

                       xticks = findTick(x_range);
                       for k = 1 : length(xticks)
                            pen.newpath();
                            xyt = coord_trans([xticks[k], 0]);
                            pen.moveto(xyt[1], oxy[2]);
                            pen.rlineto(0, parent.xticklen);
                            pen.stroke();
                            if k == 1
                                 pen.showHorText(xyt[1] + 5, oxy[2]- 12, sprintf("%g", xticks[k]));
                            else
                                 pen.showHorText(xyt[1], oxy[2]- 12, sprintf("%g", xticks[k]));
                            end
                       end
                       
                       yticks = findTick(y_range);
                       for k = 1 : length(yticks)
                            pen.newpath();
                            xyt = coord_trans([0, yticks[k]]);
                            pen.moveto(oxy[1], xyt[2]);
                            pen.rlineto(parent.yticklen, 0);
                            pen.stroke();
                            pen.showRightAlignedText(oxy[1] - 5, xyt[2], sprintf("%g", yticks[k]));
                       end

                       if parent.xlabel != ""
                            pen.showHorText(llx + fw + 27, oxy[2] - 12, parent.xlabel);
                       end

                       if parent.ylabel != ""
                            pen.showHorText(oxy[1], lly + fh + 40, parent.ylabel);
                       end
               end
         end

/* every object must have x attribute and y attribute which represents its
 * location, and draw function */

global.figure = class 
                     /* the vector of all objects */
                     public objects = (~);
                     
                     private xrange = [];
                     private yrange = [];

                     private xticklen = 6;
                     private yticklen = 6;

                     public style = "boxed" in {"boxed", "grid", "center", "empty"};
                     public linetype = "solid" in {"solid", "dotty", "dash", "dashdot", "dot", "arc", "curve"};
                     public linewidth = 1 in _R;
                     public color = [0, 0, 0];
                     public fillcolor = [];
                     public gray = 1;
                     public font = "Helvetica" in {"Times", "Helvetica", "Courier", "Symbol"};
                     public fontstyle = "Regular" in {"Regular", "Bold", "Italic", "BoldItalic"};
                     public fontscale = 1 in _R;
                     
                     public title = "" in _string;  /* color ?? */
                     public xlabel = "" in _string; 
                     public ylabel = "" in _string; 
                     
                     common setXrange = function xr -> ()
                                             if xr.length == 2 && xr[1] <= xr[2]
                                                  parent.xrange = xr;
                                             end
                                        end

                     common setYrange = function yr -> ()
                                             if yr.length == 2 && yr[1] <= yr[2]
                                                  parent.yrange = yr;
                                             end
                                        end

                     common getXrange = function () -> xr
                                             if #(parent.xrange) != 0
                                                  xr = parent.xrange;
                                             elseif #(parent.objects) == 0
                                                  xr = [0, 1];
                                             else
                                                  path = parent.objects # 1;
                                                  r = path.xrange;
                                                  x0 = r[1];
                                                  x1 = r[2];
                                                  for k = 2 : # (parent.objects)
                                                       path = parent.objects # k;
                                                       r = path.xrange;
                                                       x0 = min(x0, r[1]);
                                                       x1 = max(x1, r[2]);
                                                  end                                                      
                                                  xr = [x0, x1];
                                             end
                                             if xr[1] == xr[2]
                                                  xr = [xr[1] - 0.5, xr[2] + 0.5];
                                             end
                                         end


                     common getYrange = function () -> yr
                                             if #(parent.yrange) != 0
                                                  yr = parent.yrange;
                                             elseif #(parent.objects) == 0
                                                  yr = [0, 1];
                                             else
                                                  path = parent.objects # 1;
                                                  r = path.yrange;
                                                  y0 = r[1];
                                                  y1 = r[2];
                                                  for k = 2 : # (parent.objects)
                                                       path = parent.objects # k;
                                                       r = path.yrange;
                                                       y0 = min(y0, r[1]);
                                                       y1 = max(y1, r[2]);
                                                  end                                                      
                                                  yr = [y0, y1];
                                             end
                                             if yr[1] == yr[2]
                                                  yr = [yr[1] - 0.5, yr[2] + 0.5];
                                             end
                                         end

                                       /* x, y, linetype, linewidth, color */
                     common plot = function (x, y, linetype="solid", linewidth=1, color=[0,0,0], gray = 1) -> ()
                                        if linetype == "solid" || linetype == "-"
                                                  parent.objects # ($ + 1) = Path.new(x, y, "solid", linewidth, color, gray); 
                                        elseif linetype == "dotty" || linetype == "..." || linetype == ".."
                                                  parent.objects # ($ + 1) = Path.new(x, y, "dotty", linewidth, color, gray); 
                                        elseif linetype == "dash" || linetype == "---" || linetype == "--"
                                                  parent.objects # ($ + 1) = Path.new(x, y, "dash", linewidth, color, gray); 
                                        elseif linetype == "dashdot" || linetype == "-."
                                                  parent.objects # ($ + 1) = Path.new(x, y, "dashdot", linewidth, color, gray); 
                                        elseif linetype == "dot" || linetype == "."
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "dot", linewidth, color, gray); 
                                        elseif linetype == "circle" || linetype == "o" || linetype == "O"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "circle", linewidth, color, gray); 
                                        elseif linetype == "square"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "square", linewidth, color, gray); 
                                        elseif linetype == "star"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "star", linewidth, color, gray); 
                                        elseif linetype == "diamond"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "diamond", linewidth, color, gray); 
                                        elseif linetype == "cross" || linetype == "x" || linetype == "X"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "cross", linewidth, color, gray); 
                                        elseif linetype == "flake"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "flake", linewidth, color, gray); 
                                        elseif linetype == "asterisk" || linetype == "*"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "asterisk", linewidth, color, gray); 
                                        elseif linetype == "utriangle" || linetype == "triangle"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "utriangle", linewidth, color, gray); 
                                        elseif linetype == "dtriangle"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "dtriangle", linewidth, color, gray); 
                                        elseif linetype == "plus" || linetype == "+"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "plus", linewidth, color, gray); 
                                        elseif linetype == "oval"
                                                  parent.objects # ($ + 1) = Dots.new(x, y, "oval", linewidth, color, gray); 
                                        elseif linetype == "curve"
                                                  parent.objects # ($ + 1) = Curve.new(x, y, "solid", linewidth, color, gray); 
                                        end
                                   end         
                     common clear = function () -> ()
                                    parent.objects = (~);
                                  end

                     common print = function (x, y, content, orientation, alignment, color, font, fontstyle, fontscale) -> ()
                                           parent.objects # ($ + 1) =  ...
                                                   Text.new(x, y, content, orientation, alignment, color, font, fontstyle, fontscale);
                                      end

                      /* new = (ox, oy, a, b, theta, type, color) -> (); */

                     common ellipse = function (ox, oy, a, b, theta, type = "contour", color = [0, 0, 0]) -> ()
                                           parent.objects # ($ + 1) = Ellipse.new(ox, oy, a, b, theta, type, color);
                                      end

                     /* common line = function (P0, P1, style, linetype, linewidth, color) -> () */
                     common line = function (P0, P1, style = "-", linetype = "solid", linewidth = 1, color = [0, 0, 0]) -> ()
                                           parent.objects # ($ + 1) = Line.new(P0, P1, style, linetype, parent.linewidth, color);
                                      end

                     /* common polygon = function (x, y, type, color) -> () */
                     common polygon = function (x, y, type = "solid", color = [1, 1, 1]) -> ()
                                           parent.objects # ($ + 1) = Polygon.new(x, y, type, color);
                                      end


                     /* common rectangle = function (x, y, width, height, style, cornersize, type, color) -> () */
                     common rectangle = function (x, y, width, height, style = "plain", cornersize = 0, type = "contour", color = [0, 0, 0])-> ()
                                           parent.objects # ($ + 1) = Rectangle.new(x, y, width, height, style, cornersize, type, color);
                                      end
                     
                     common save = function filename -> ()
                                      xrange = parent.getXrange();
                                      xspan = xrange[2] - xrange[1];
                                      yrange = parent.getYrange();
                                      yspan = yrange[2] - yrange[1];
                                      painter = epspainter.new(filename);
												  painter.newpath();
                                      bbox = painter.bbox;
                                      bw = bbox[3] - bbox[1];
                                      bh = bbox[4] - bbox[2];
                                      
                                      llx = bw * 0.08 + bbox[1];
                                      lly = bh * 0.02 + bbox[2];
                                      fw = bw * 0.9;
                                      fh = bh * 0.96;

                                      coord_trans = scale_trans;
                                      coord_trans.kx = fw / xspan;
                                      coord_trans.ky = fh / yspan;
                                    
                                      coord_trans.bx = llx  - xrange[1] * fw / xspan;
                                      coord_trans.by = lly  - yrange[1] * fh / yspan;

                                      if (parent.style == "boxed")
                                           picbox = figurebox.new(xrange, yrange, llx, lly, fw, fh, parent.xlabel, parent.ylabel, 0);
                                      elseif (parent.style == "grid")
                                           picbox = figurebox.new(xrange, yrange, llx, lly, fw, fh, parent.xlabel, parent.ylabel, 1);
                                      elseif (parent.style == "center")
                                           picbox = figureaxis.new(xrange, yrange, llx, lly, fw, fh, parent.xlabel, parent.ylabel, 1);
                                      else
                                           picbox = ();
                                      end

                                      if picbox != ()
                                           picbox.draw(painter, coord_trans);
                                      end
                                      if parent.title != ""
                                           painter.showHorText(llx + fw / 2, lly + fh + 20, parent.title);
                                      end

                                      /* the clipping area */
                                      painter.newpath();
                                      painter.moveto(llx, lly);
                                      painter.rlineto(fw, 0);
                                      painter.rlineto(0, fh);
                                      painter.rlineto(-fw, 0);
                                      painter.closepath();
                                      painter.clip();
                                      painter.newpath();

                                      for k = 1 : # (parent.objects)
                                           path = (parent.objects)#k;
                                           path.draw(painter, coord_trans);

                                      end

                                      painter.close();
                            end
                     end




global.piechart = class 
                      public percentages = 1;
                      public labels = (~);
                      public title = "test pie chart";
                      public colors = ([1, 0, 0], [0, 1, 0], [0, 0, 1], [1, 0, 1],
                                       [0, 1, 1], [1, 0.7, 0], [0.7, 0.3, 1], [0.7, 0.3, 0],
                                       [0, 0.5, 0]
                                      );

                      public font = "Helvetica" in {"Times", "Helvetica", "Courier", "Symbol"};
                      public fontstyle = "Regular" in {"Regular", "Bold", "Italic", "BoldItalic"};
                      public fontscale = 2;
                      public color = [0, 0, 1];
                      
                      
                      public makefontname = function () -> fontname
                                                 if parent.fontstyle == "Regular" || parent.font == "Symbol"
                                                      fontname = parent.font;
                                                 else
                                                      fontname = parent.font + "-" + parent.fontstyle;
                                                 end
                                             end


                      /* check to make sure percentages add up to 1, and sort
							  * them before assigning */

                      new = function (percentages, labels) -> ()
                                 if #percentages == #labels
                                      if # percentages > 9
                                          panic("too many data");
                                      end
                                      for k = 1 : #percentages
                                           p = percentages # k;
                                           l = labels # k;
                                           if ! ((p in _R) && (l in _string))
                                                panic("invalud parameters for making pie chart");
                                           end
                                      end
                                      if sum(percentages) != 1
                                          panic("percentages don't sum up to 1");
                                      end
                                 else
                                      panic("numbers of percentages and labels don't match");
                                 end
                            end

                      common save = function filename -> ()
                                       
                                       painter = epspainter.new(filename);
                                       bbox = painter.bbox;
                                       
                                       bw = bbox[3] - bbox[1];
                                       bh = bbox[4] - bbox[2];
                                       
                                       llx = bw * 0.12 + bbox[1];
                                       lly = bh * 0.12 + bbox[2];
                                       fw = bw * 0.8;
                                       fh = bh * 0.8;
                                         
                                       xo = llx + fw / 2 - 50;
                                       yo = lly + fh / 2;

                                       R = min(fw, fh) / 3.0;

                                       painter.drawbox(llx, lly, fw, fh, []);

                                       painter.moveto(xo, yo);
                                       
                                       theta = 0;
                                       N = # (parent.percentages);


                                       painter.setfont(parent.makefontname(), parent.fontscale * 15);
                                       painter.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);

                                       for k = 1 : N 
                                            dtheta = (parent.percentages # k) * 360;
                                            painter.arc(xo, yo, R, theta, theta + dtheta);
                                            painter.closepath();
                                            color = parent.colors # k;
                                            painter.setrgbcolor(color[1], color[2], color[3]);
                                            painter.fill();
                                            xx = xo + 0.65 * R * cos((theta + dtheta / 2) / 180 * pi);
                                            yy = yo + 0.65 * R * sin((theta + dtheta / 2) / 180 * pi);
                                            painter.setrgbcolor(1, 1, 1);
                                            painter.showHorText(xx, yy, sprintf("%g%%", 100 * parent.percentages # k));
                                            theta += dtheta;
                                            painter.newpath();
                                            painter.moveto(xo, yo);
                                       end

                                       yt = lly + fh / 2 + 10 * N;
                                       xt = llx + fw - 35;

                                       painter.setrgbcolor(0, 0, 0);
                                       for k = 1 : N
                                          painter.drawbox(xt, yt, 10, 10, parent.colors # k);
                                          painter.showRightAlignedText(xt - 20, yt+ 5, parent.labels  # k);
                                          yt -= 20;
                                       end


                                       if parent.title != ""
                                            painter.showHorText(llx + fw / 2, lly + fh + 20, parent.title);
                                       end

                                       painter.close();

                                    end
                  end

global.histogram = class
                      public yvalues = 1;
                      public xlabels = "";
                      public colors = ([1, 0, 0], [0, 1, 0], [1, 0, 1], [0, 0, 1],
                                       [0, 1, 1], [1, 0.7, 0], [0.7, 0.3, 1], [0.7, 0.3, 0],
                                       [0, 0.5, 0]
                                      );
                      public yrange = [];
                      public title = "" in _string;
                      public grouplabels = (~);

                      new = function (xlabels, yvalues, grouplabels = (~)) -> ()
                                 ngroups = #grouplabels;
                                 nbars = #xlabels;
                                 if ngroups > 0
                                      if #yvalues == ngroups
                                           for j = 1 : nbars
                                              if ! ((xlabels # j) in _string)
                                                   panic("invalid data value");
                                              end
                                           end
                                           for k = 1 : ngroups
                                                label = grouplabels # k;
                                                if !(label in _string)
                                                     panic("invalid data label");
                                                end
                                                yv = yvalues # k;
                                                if #yv != nbars
                                                     panic("number of values and lables don't match");
                                                end
                                                for j = 1 : nbars
                                                     if ! ((yv # j) in _R)
                                                          panic("invalid data value");
                                                     end
                                                end
                                           end
                                      else
                                           panic("number of values and lables don't match");
                                      end
                                 elseif #yvalues == nbars
                                      for j = 1 : nbars
                                           if ! ((xlabels # j) in _string)
                                                panic("invalid data value");
                                           end

                                           if ! ((yvalues # j) in _R)
                                                panic("invalid data value");
                                           end
                                      end
                                 else
                                      panic("number of values and lables don't match");
                                 end
                            end

                      public font = "Helvetica" in {"Times", "Helvetica", "Courier", "Symbol"};
                      public fontstyle = "Regular" in {"Regular", "Bold", "Italic", "BoldItalic"};
                      public fontscale = 2;
                      public color = [0, 0, 1];
                      
                      
                      public makefontname = function () -> fontname
                                                 if parent.fontstyle == "Regular" || parent.font == "Symbol"
                                                      fontname = parent.font;
                                                 else
                                                      fontname = parent.font + "-" + parent.fontstyle;
                                                 end
                                             end

                      common save = function filename -> ()
                                       
                                       painter = epspainter.new(filename);
                                       bbox = painter.bbox;
                                       
                                       bw = bbox[3] - bbox[1];
                                       bh = bbox[4] - bbox[2];
                                       
                                       llx = bw * 0.12 + bbox[1];
                                       lly = bh * 0.12 + bbox[2];
                                       fw = bw * 0.8;
                                       fh = bh * 0.8;

                                       yvalues = parent.yvalues; 
                                       ngroups = #(parent.xlabels);

                                       if ngroups == 1
                                            hmax = max(yvalues);
                                       elseif ngroups == 2
                                            hmax = max(max(yvalues # 1), max(yvalues # 2));
                                       elseif ngroups == 3
                                            hmax = max(max(yvalues # 1), max(yvalues # 2), max(yvalues # 3));
                                       end

                                       if parent.yrange == []
                                            yrange = [0, hmax * 1.2];
                                       else
                                            yrange = parent.yrange;
                                       end

                                       painter.drawbox(llx, lly, fw, fh, []);


                                       if parent.title != ""
                                            painter.showHorText(llx + fw / 2, lly + fh + 20, parent.title);
                                       end

                                       yticks = findTick(yrange);

                                       painter.setlinetype("dotty");

                                       painter.setfont(parent.makefontname(), parent.fontscale * 15);
                                       painter.setrgbcolor(parent.color[1], parent.color[2], parent.color[3]);

                                       for k = 1 : length(yticks)
                                            painter.newpath();

                                            yt = (yticks[k] - yrange[1]) / (yrange[2] - yrange[1]) * fh + lly;

                                            painter.moveto(llx, yt);

                                            painter.rlineto(fw, 0);
                                            painter.stroke();
                                            painter.showRightAlignedText(llx - 9, yt, sprintf("%g", yticks[k]));
                                       end
                                       painter.setlinetype("solid");

                                       n = #(parent.xlabels);
                                       dw = fw / (n + 1);
                                       x = llx + dw;
                                       barwidth = dw * 0.6;
                                       hfactor = fh / (yrange[2] - yrange[1]);

                                       if ngroups == 1
                                            for k = 1 : n
                                                for j = 1 : ngroups
                                                     painter.drawbox(x - barwidth / 2, lly, barwidth, (yvalues # k) * hfactor , [0, 1, 0]);
                                                end
                                                painter.showHorText(x, lly - 15, parent.xlabels # k);
                                                x += dw;
                                            end
                                       else
                                            for k = 1 : n
                                                gwidth = barwidth / ngroups;
                                                gstart = x - barwidth / 2;
                                                for j = 1 : ngroups
                                                     painter.drawbox(gstart, lly, gwidth, ((yvalues #j) # k) * hfactor , parent.colors # j);
                                                     painter.drawbox(llx + fw - 35, lly + fh - 30 * j, 10, 10, parent.colors # j);
                                                     painter.showRightAlignedText(llx + fw - 55, lly + fh - 30 * j + 5, parent.grouplabels  # j);
                                                     gstart += gwidth;
                                                end
                                                painter.showHorText(x, lly - 15, parent.xlabels # k);
                                                x += dw;
                                            end
                                       end

                                       painter.close();
                                     end
                  end


/*
x1 = linspace(0, 1.5*pi, 100);
x2 = linspace(0.5*pi, 2*pi, 100);

x = [x1, x2];
   
y = 0.39*sin(2*x);
z = 1.22*cos(3*x);
*/


/*
P = x -> 0.02 * x.^3 + 10 - x.^2 + x - 1;
*/

/*
x = [1.3, 0.5, 0, 1, 1, 0, -0.5];
y = [0.7, 0.7, 1, 1, 0, 0, 1];
*/

/*
x = linspace(-2,3,15);
xx = [-2, -1, 0, 0.5, 1, 2, 3];
yy = P(xx) - 3;
y = P(x) - 3;


fig = figure.new();
*/

/*
fig.plot{x=x,y=y, linetype="curve"};
fig.plot{x=xx,y=yy, linetype="curve"};
fig.plot{x=x, y=y, linetype="diamond", linewidth=3, color=[1, 0, 0.3]};
fig.print(0.5, 3, "Shang", "portrait", "center", [0, 0, 1], "Courier", "BoldItalic", 3);
*/


/*
fig.ellipse(1, 4, 0.5, 0.2, 0, "solid", [0.5, 0.5, 0.5]);
fig.ellipse(0.0, 0.7, 0.5, 0.2, -pi/6, "solid", [1, 0, 1]);
fig.polygon([1.2, 2, 0.3], [2.5, 0, 0.8], "contour", [0, 0, 1]);
fig.rectangle(0.5, 0, 1.2, 0.8, "beveled", [0.15, 0.1], "solid", [0.8, 1, 0.3]);
*/

//fig.line([0,2],  [0.5, 5.2], "<->", "solid", 1, [0,0, 0]);

// fig.plot(x,y, "star", 3, [1, 0, 0])
//fig.plot(x,z, "solid", 1, [1, 0, 1])
//fig.plot(x,z, "oval", [5,7], [0, 0, 1])

//fig.title = "test figure";
//fig.style = "boxed";
/*
fig.setYrange([-0.5, 1.5]);
fig.setXrange([-0.5, 1.5]);
*/
//fig.xlabel = "xxx";
//fig.ylabel = "yyy";
//fig.save("uvw.eps")

global.surface = class 
                     public urange = [0, 2];
                     public vrange = [0, 2 * pi];

                     public frontcolor = [0.431, 0.906, 0.318];
                     public bgcolor = [0.918, 0.451, 0.631];

                     public meshsize = [50, 50];

                     public xf = (u, v) -> u * cos(v);
                     public yf = (u, v) -> u * sin(v);
                     public zf = (u, v) -> u^2;

                     new = (xf, yf, zf, urange, vrange, meshsize, frontcolor, bgcolor)-> ()
                  end


global.figure3d = class 
          public light_direction = [2/3, 2/3, 1/3];
//           public light_direction = [2/3, -2/3, 1/3];

          public viewing_distance = 70;

          public patches = (~);

          public surfaces = (~);

          public curves = (~);

          public xrange = [];
          public yrange = [];
          public zrange = [];

          common plot = function (xf, yf, zf, urange, vrange, meshsize, frontcolor, bgcolor) -> ()
                 parent.surfaces # ($ + 1) = surface.new(xf, yf, zf, urange, vrange, meshsize, frontcolor, bgcolor);
          end

			 common clear = function () -> ()
               parent.patches = (~);
               parent.surfaces = (~);
               parent.curves = (~);
             end

          common curve = function (x, y, z, color, lw) -> ()
               lv = parent.light_direction / norm(parent.light_direction);
               d0 = parent.viewing_distance;
               OS = d0 * lv; // viewing screen origion

               U = [lv[2], -lv[1], 0]; // viewing screen horizontal
               V = cross(U, lv);      // viewing screen vertial

               n = x.length;

               xx = zeros(n, 1);
               yy = zeros(n, 1);
               d = 0;

               for j = 1 : n
                    P1 = [x[j], y[j], z[j]];
                    
                    P1OS = OS - P1;
                    
                    dis = dot(P1OS, lv);
                    
                    P = P1 + dis * lv;
                    
                    OSP = P - OS;
                    
                    xx[j] = dot(OSP, U);
                    yy[j] = dot(OSP, V);
               end

               if parent.xrange == []
                   parent.xrange = x.range;
               end

               if parent.yrange == []
                   parent.yrange = y.range;
               end

               if parent.zrange == []
                   parent.zrange = z.range;
               end

               parent.curves # ($ + 1) = {x = xx, y = yy, color = color, lw = lw}; 
          end

          common polygon = function (x, y, z, nv, frontcolor, bgcolor) -> ()
               lv = parent.light_direction / norm(parent.light_direction);
               d0 = parent.viewing_distance;
               OS = d0 * lv; // viewing screen origion

               U = [lv[2], -lv[1], 0]; // viewing screen horizontal
               V = cross(U, lv);      // viewing screen vertial

               n = x.length;

               xx = zeros(n, 1);
               yy = zeros(n, 1);
               d = 0;

               xm = x.mean;
               ym = y.mean;
               zm = z.mean;

               for j = 1 : n
                    P1 = [x[j], y[j], z[j]];
                    
                    P1OS = OS - P1;
                    
                    dis = dot(P1OS, lv);
                    
                    P = P1 + dis * lv;
                    
                    OSP = P - OS;
                    
                    xx[j] = dot(OSP, U);
                    yy[j] = dot(OSP, V);
                    d += abs(dis);
               end
               
               
					/*
               for j = 1 : #(parent.patches)
                    if d > (parent.patches # j).d
                         break;
                    end
               end

               for k = #(parent.patches) : -1 : j
                    parent.patches # (k + 1) = parent.patches # k;
               end
					*/


               nvlen = norm(nv);
               if nvlen != 0
                    c = (nv[1] + nv[2] + nv[3]) / nvlen / sqrt(3);
               else
                    c = 0;
               end

               if dot(nv, lv) < 0
                    c = (abs(c) + 0.8) / 2;
                    c = c * frontcolor;
               else
                    c = abs(c);
                    c = (abs(c) + 0.8) / 2;
                    c = c * bgcolor;
               end

               parent.patches # ($ + 1) = {xx = xx, yy = yy, d = d, c = c};

          end


          common mesh = function (v, frontcolor, bgcolor) -> ()

                 for j = 1 : v.nrows - 1
                     for k = 1 : v.ncolumns - 1
                          X = [j - 1, j - 1, j, j];
                          Y = [k - 1, k, k, k - 1];
                          Z = v[X + 1; Y + 1];
                          A = [X[1], Y[1], Z[1]];
                          B = [X[2], Y[2], Z[2]];
                          C = [X[3], Y[3], Z[3]];

                          nv = cross(A - B, A - C);

                          parent.polygon (X, Y, Z, nv, frontcolor, bgcolor);
                     end
                 end
          end

          common save = function filename -> ()
//                parent.patches = ();
#(parent.patches)
                for L = 1 : # (parent.surfaces)
                     s = parent.surfaces # L;
                     urange = s.urange;
                     vrange = s.vrange;
                     fx = s.xf;
                     fy = s.yf;
                     fz = s.zf;
                     
                     M = s.meshsize[1];
                     N = s.meshsize[2];
                     u = urange[1];
                     du = (urange[2] - urange[1]) / M;
                     v = vrange[1];
                     dv = (vrange[2] - vrange[1]) / N;
                     
                     for k = 0 : M - 1
                         u = urange[1];
                         for j = 0 : N - 1
                              x0 = fx(u, v);
                              y0 = fy(u, v);
                              z0 = fz(u, v);
                     
                              x1 = fx(u + du, v);
                              y1 = fy(u + du, v);
                              z1 = fz(u + du, v);
                     
                              x2 = fx(u, v + dv);
                              y2 = fy(u, v + dv);
                              z2 = fz(u, v + dv);
                     
                              x3 = fx(u + du, v + dv);
                              y3 = fy(u + du, v + dv);
                              z3 = fz(u + du, v + dv);
                        
                              nv = cross([x1 - x0, y1 - y0, z1 - z0], [x2 - x0, y2 - y0, z2 - z0]);
                     
                              parent.polygon([x0, x1, x3, x2], [y0, y1, y3, y2], [z0, z1, z3, z2], nv, s.frontcolor, s.bgcolor);
                              u += du;
                         end
                         v += dv;
                     end
                end          

                fig = global.figure.new();
                fig.style = "empty";

                if # parent.patches > 0
                     dm = zeros(#parent.patches);
                     for j = 1 : dm.length
                         dm[j] = (parent.patches # j).d;
                     end
                     
                     I = indexsort(dm);
                     I.reverse();
                     
                     parent.patches = parent.patches # I;
                     
                     for j = 1 : # (parent.patches)
                          t = parent.patches # j;
                          fig.polygon(t.xx, t.yy, "solid", t.c);
                     end
                end

/*
                box = [];

                if parent.xrange != [] && parent.yrange != [] && parent.zrange != []
                     box = zeros(8, 3);
                     box[1,:] = [parent.xrange[1], parent.yrange[1], parent.zrange[1]];
                     box[2,:] = [parent.xrange[2], parent.yrange[1], parent.zrange[1]];
                     box[3,:] = [parent.xrange[2], parent.yrange[2], parent.zrange[1]];
                     box[4,:] = [parent.xrange[1], parent.yrange[2], parent.zrange[1]];

                     box[5,:] = [parent.xrange[1], parent.yrange[1], parent.zrange[2]];
                     box[6,:] = [parent.xrange[2], parent.yrange[1], parent.zrange[2]];
                     box[7,:] = [parent.xrange[2], parent.yrange[2], parent.zrange[2]];
                     box[8,:] = [parent.xrange[1], parent.yrange[2], parent.zrange[2]];

                     lv = parent.light_direction / norm(parent.light_direction);
                     d0 = parent.viewing_distance;
                     OS = d0 * lv; // viewing screen origion
                     
                     U = [lv[2], -lv[1], 0]; // viewing screen horizontal
                     V = cross(U, lv);      // viewing screen vertial
                     
                     xx = zeros(8, 1);
                     yy = zeros(8, 1);
                     d = 0;
                     
                     for j = 1 : 8
                          P1 = [box[j, 1], box[j, 2], box[j, 3]];
                          
                          P1OS = OS - P1;
                          
                          dis = dot(P1OS, lv);
                          
                          P = P1 + dis * lv;
                          
                          OSP = P - OS;
                          
                          xx[j] = dot(OSP, U);
                          yy[j] = dot(OSP, V);
                     end

                     /* bottom */
                     fig.line([xx[1], yy[1]], [xx[2], yy[2]], "-", "dotty");
                     fig.line([xx[2], yy[2]], [xx[3], yy[3]]);
                     fig.line([xx[3], yy[3]], [xx[4], yy[4]]);
                     fig.line([xx[4], yy[4]], [xx[1], yy[1]], "-", "dotty");

                     /* back */
                     fig.line([xx[1], yy[1]], [xx[5], yy[5]], "-", "dotty");
                     fig.line([xx[4], yy[4]], [xx[8], yy[8]]);
                     fig.line([xx[8], yy[8]], [xx[5], yy[5]]);


                end
*/
                for j = 1 : # (parent.curves)
                     t = parent.curves # j;
                     fig.plot (t.x, t.y, "curve", t.lw, t.color);

//                     common plot = function (x, y, linetype="solid", linewidth=1, color=[0,0,0], gray = 1) -> ()

                end
					 /*
                if box != []
                     fig.line([xx[2], yy[2]], [xx[6], yy[6]]);
                     fig.line([xx[3], yy[3]], [xx[7], yy[7]]);

                     fig.line([xx[5], yy[5]], [xx[6], yy[6]]);
                     fig.line([xx[6], yy[6]], [xx[7], yy[7]]);
                     fig.line([xx[7], yy[7]], [xx[8], yy[8]]);
                end
					 */
                fig.save(filename);
          end
end
/*



fig = figure3d.new();
fig.plot((z,theta)->2.5*cos(theta), (z,theta)->2.5*sin(theta), (z,theta)->z, [-0.8,0.8],[0,2*pi], 10, 10);

fig.plot((y,theta)->0.5*cos(theta), (y,theta)->y, (y,theta)->0.5*sin(theta), [-3,3],[0,2*pi], 8,4);

//fig.plot((x,y)->x, (x,y)->y, (x,y)->x+y,[-2,2], [-2,2]);

fig.save("cyll.eps");


*/
