

/* this is the recursive adaptive simpson rule */
global.adapt_simpson = function (f, a, c, b, fa, fc, fb, sab, tol) -> (s, nodes)
    h = c - a;
    d = (a + c) * 0.5;
    e = (c + b) * 0.5;

    fd = f(d);
    fe = f(e);

    h6 = h / 6;
    sac = (f(a) + f(c) + 4 * f(d)) * h6;
    scb = (f(c) + f(b) + 4 * f(e)) * h6;

    sacb = sac + scb;
    if abs(sacb - sab) <= 10 * tol
          s = sacb;
          nodes = [a, d, c, e, b];
    else
          (s1, nodes1) = this(f, a, d, c, fa, fd, fc, sac, tol / 2); 
          (s2, nodes2) = this(f, c, e, b, fc, fe, fb, scb, tol / 2);
          s = s1 + s2;
          nodes = [nodes1[1:$-1], nodes2];
    end
end

/* this is the user interface of adaptive simpson rule */

global.simpson = function (f, a, b, tol) -> (s, nodes)
             fa = f(a);
             fb = f(b);
              c = (a + b) / 2;
             fc = f(c);
             sab = (fa + fb + 4 * fc) * (b - a) / 6;
             (s, nodes) = adapt_simpson(f, a, c, b, fa, fc, fb, sab, tol);
end

